<?php

require_once('access.php');
require_once('../config.php');
require_once('../common.php');

// Get data feed list

$files = get_file_list($cfg['datafeed_dir']);
$feeds = array();
foreach ($files as $item)
   {
   $feeds[$item['filename']]['last_modified'] = date("F jS Y",$item['last_modified']);
   $feeds[$item['filename']]['file_size'] = number_format($item['file_size']);
   $feeds[$item['filename']]['filename'] = $item['filename'];
   
   $filename = urlencode($item['filename']);
   $functions  = build_link('Import',"import.php?filename=$filename",true,true);
   $feeds[$item['filename']]['functions'] = $functions;
   }

// get product count
$query = "SELECT count(*) as count from products;";
database_inquiry($query, $rows);
$prod_count = number_format($rows[0]['count']);

// get category count

$query = "SELECT count(*) as count from categories;";
database_inquiry($query, $rows);
$cat_count = number_format($rows[0]['count']);

// Generate inner template

$tpl = & new Template();
$tpl->set('feeds',$feeds);
$tpl->set('cat_count',$cat_count);
$tpl->set('prod_count',$prod_count);
$main_content = $tpl->fetch('templates/index.tpl');

// Generate outer template

$tpl2 = & new Template();
$tpl2->set('main_content',$main_content);
$x = $tpl2->fetch('templates/master.tpl');

// Generate html page

echo $x;

function build_link($title,$link,$enable,$confirm=false)
{

$url = $title;
$x = '';
if ($confirm) $x = " onclick=\"javascript:return confirm('Wipe database and import?')\"";

if ($enable) $url = "<a href=\"$link\"$x>$title</a>";

return ($url);

}
?>
