<?php

global $eof;

// guess at datafeed settings for header, separator, and quotes

function powerfeed_guess($filename, $curl=false)
{

// open file

$eof = false;
$file = fopen($filename,'r');

if (!$file) exit("Error reading $filename.");

$i=1;
$comma_count = 0;
$pipe_count = 0;
$semicolon_count = 0;
$asterisk_count = 0;
$tilde_count = 0;
$tab_count = 0;

$first = 0;
$shortest = 500;
$counters = array(',' => 0,'|' => 0,"\t" => 0,';' => 0,'*' => 0,'~' => 0);

while (!feof($file))
   {
   $line = fgets($file);

   if ($i == 1) $first = strlen($line);
   if (strlen($line) < $shortest && strlen($line) > 3) $shortest = strlen($line);

   foreach ($counters as $key => $value)
      {
      $counters[$key] += substr_count($line,$key);
      }
   $i++;
   if ($i > 50) break;
   }

$header = '0'; if ($first == $shortest) $header = '1';
$delimiter = ',';

if ($i > 5)
   {
   foreach ($counters as $key => $value)
      {
      $counters[$key] = $value / $i;
      }
   arsort($counters);
   reset($counters);
   $delimiter = key($counters);
   }

return ("$header$delimiter");

fclose($file);

}


// main function

function powerfeed($filename, $callback, $header_ind, $separator, $enclosed='', $curl=false)
{

global $eof;

$eof = false;
$file = fopen($filename,'r');

if (!$file)
   {
   exit("Error reading $filename.");
   }

$field_count = 0;
if ($header_ind == 1)
   {
   $header = read_file($file, $separator, $enclosed);
   $field_count = sizeof($header);
   }
   
while ($eof == false)
   {
   $record = read_file($file, $separator, $enclosed);
   if ($field_count == 0) $field_count = sizeof($record);
   if ($header_ind == 0)
      {
      $counter = 1;
      $newarray = array();
      foreach ($record as $item)
         {
         $x = "field$counter";
         $newarray[$x] = $item;
         $counter++;
         }
      }
   else
      {
      $counter = 0;
      $newarray = array();
      foreach ($record as $item)
         {
         @$x = strtolower($header[$counter]);
         $x = str_replace(' ','_',$x);
         if ($x == '') $x = "field$counter";
         $newarray[$x] = $item;
         $counter++;
         }
      }

   if ($field_count == sizeof($newarray)) $x = call_user_func($callback, $newarray);
   if ($x == 1) $eof = true;
   }

fclose($file);

return;
}

function read_file($file, $separator, $enclosed)
{
global $eof;

$in_field = false;
$eor = false;
$record = array();
$field = '';

while(!$eor && !$eof)
   {
   $char = fgetc($file);

   if ($char === false)
      {
      $eof = true;
      $record[] = $field;
      $in_field = false;
      break; // end of file
      }

   if ($char == "\r")
      {
      continue;  // ignore carriage returns
      }

   if ($char == $enclosed)
      {
      $in_field = !$in_field;
      continue;
      }

   if ($char == "\n")
      {
      $eor = true;
      $record[] = $field;
      $in_field = false;
      break; // end of record
      }

   if ($char == $separator && $in_field == false)
      {
      $record[] = $field;
      $field = '';
      continue; // next field
      }
   
   $field .= $char;      

   }

return($record);

}

?>
