<?php

require_once('config.php');
require_once('common.php');

$search = custom_get('search');
$page = custom_get('page',1);

if (!is_numeric($page)) $page = 1;

// get category lists

$query = "SELECT * from categories WHERE parent_id = '$cfg[default_category]';";
database_inquiry($query, $rows);
$categories = $rows;

// set database limits

$start = ($page-1)*$cfg['products_per_page'];
$limits = " LIMIT $start,$cfg[products_per_page]";

// create next/prev links

$query = "SELECT count(*) AS count from products WHERE match(calendar_title) AGAINST('$search');";
database_inquiry($query, $rows);
$product_count = $rows[0]['count'];

$total_pages = $product_count / $cfg['products_per_page'];
if ($total_pages != intval($total_pages)) $total_pages++;
$total_pages = (int) $total_pages;
if ($total_pages < 1) $total_pages = 1;

// create page numbers

$from_page = $page-4;
$to_page = $page+4;
if ($from_page < 1){$from_page = 1;}
if ($to_page > $total_pages){$to_page = $total_pages;}

$page_array = '';
for ($i=$from_page;$i<=$to_page;$i++)
   {
   $page_array .= "<a href=\"search.php?search=$search&page=$i\">$i </a>";
   }

$next_prev = '';
$prev_page = $page-1;
$next_page = $page+1;
if ($page > 1) $next_prev .= "<a href=\"search.php?search=$search&page=$prev_page\">&lt;&lt;Prev</a> | "; else $next_prev .= "&lt;&lt;Prev | ";
$next_prev .= $page_array;
if ($page < $total_pages) $next_prev .= "<a href=\"search.php?search=$search&page=$next_page\">| Next&gt;&gt;</a>"; else $next_prev .= "| Next&gt;&gt;";

// Get product list

$query = "SELECT * from products WHERE match(calendar_title) AGAINST('$search')$limits;";
database_inquiry($query, $rows);
$products = $rows;

// format price
$i=0;
foreach ($products as $item)
   {
   $item['price'] = '$'.number_format($item['price'],2,'.',',');
   $products[$i] = $item;
   $i++;
   }

// Generate inner template

$tpl = & new Template();
$tpl->set('products',$products);
$tpl->set('next_prev',$next_prev);
$main_content = $tpl->fetch('templates/search.tpl');

// Generate outer template

$tpl2 = & new Template();
$tpl2->set('main_content',$main_content);
$tpl2->set('categories',$categories);
$x = $tpl2->fetch('templates/master.tpl');

// Generate html page

echo $x;

?>
